// bigmap.c: Big-map related functions for Bapple2.  Created on March 2nd, 1998..
//
// This stuff is for a full-screen map view that has been left unfinished for now..

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include <allegro.h>
#include "bapple2.h"
#include "bap2dat.h"
#include "globals.h"
#include "map.h"

BITMAP *big_map = 0;

void display_big_map(void);
void redraw_terrain_cache(void);

/* init_map_view(): -------------------------------------------------------
 *   Initializes the large map view (triggered by F2?)
 */
void init_map_view(void)
{
	int x, y, i, r, g, b;
	int iw, ih, ow, oh, ix, iy;
	float iw_ow, ih_oh;

	// Create a bitmap for the big_map view
	if (!big_map)
		big_map = create_bitmap(SCREEN_W, SCREEN_H);

	// Redraw that 1:1 terrain cache bitmap
	redraw_terrain_cache();

	// Set up scaling parameters
	iw = MAP_WIDTH;
	ih = MAP_HEIGHT;
	ow = SCREEN_W;
	oh = SCREEN_H;

	// Scale the terrain data up nicely for the big_map view
	iw_ow = (float) iw / (float) ow;
	ih_oh = (float) ih / (float) oh;
	for (y = 0; y < oh; y++)
		for (x = 0; x < ow; x++)
		{
			r = g = b = 0;
			ix = (int) (x * iw_ow);
			iy = (int) (y * ih_oh);
//			i = getpixel(terrain_bmp, ix, iy);
            i = getpixel(terrain_bmp, ix - 1, iy - 1); 		// NW
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 0, iy - 1); 		// N
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 1, iy - 1); 		// NE
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix - 1, iy + 0); 		// W
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 0, iy + 0); 		// Center
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 1, iy + 0); 		// E
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix - 1, iy + 1); 		// SW
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 0, iy + 1); 		// S
			r += getr(i);
			g += getg(i);
			b += getb(i);
			i = getpixel(terrain_bmp, ix + 1, iy + 1); 		// SE
			r += getr(i);
			g += getg(i);
			b += getb(i);
			r /= 9;
			g /= 9;
			b /= 9;
//			putpixel(big_map, x, y, i);
			putpixel(big_map, x, y, makecol(r, g, b));
		}
}

/* redraw_terrain_cache(): ------------------------------------------------
 *   Redraws the terrain cache bitmap, which serves as the background
 *   for the mini-map.  This bitmap is only redrawn when necessary.
 */
void redraw_terrain_cache(void)
{
	int x, y, c, offset;

		redraw_terrain_bmp = 0;
		// Draw terrain
		offset = 0;
		for (y = 0; y < MAP_HEIGHT; y++)
		{
			for (x = 0; x < MAP_WIDTH; x++)
			{
				switch (terrain[offset++])
				{
					case TERRAIN_LAND:    c = makecol(125, 76, 64); break;	// 194
					case TERRAIN_WATER:   c = makecol(97, 97, 165); break;	// 120
					case TERRAIN_COAST:   c = makecol(121, 101, 85); break;	// 224
					case TERRAIN_BLOCKED: c = makecol(85, 85, 85);  break;	// 20
				}
	            putpixel(terrain_bmp, x, y, c);
			}
		}
}

/* display_big_map(): -----------------------------------------------------
 *   Draws the BIG map...
 */
void display_big_map(void)
{
	int i, x, y, sx, sy, xoff, yoff, offset;
	unsigned char c;
	unit_t *u;

	// Calculate starting coordinates
	sx = (PhysicalWidth / 2) - (MAP_WIDTH / 2) + 32;
	sy = (PhysicalHeight / 2) - (MAP_HEIGHT / 2) + 32;

	if (game_state != GAME_STATE_MAP)
	{
		sx = LogicalWidth - 34 - MAP_WIDTH;
		sy = LogicalHeight - 34 - MAP_HEIGHT;
	}

	// Draw window shadow
//    rect(HiddenPage, sx + 1, sy + 1, sx + MAP_WIDTH + 2, sy + MAP_HEIGHT + 2, 16);
//    rect(HiddenPage, sx + 1, sy + 1, sx + MAP_WIDTH + 3, sy + MAP_HEIGHT + 3, 24);
	// Draw window frame
//    rect(HiddenPage, sx, sy, sx + MAP_WIDTH + 1, sy + MAP_HEIGHT + 1, 1);

	sx++;
	sy++;

	if (redraw_terrain_bmp)
		redraw_terrain_cache();

//    blit(terrain_bmp, HiddenPage, 0, 0, sx, sy, MAP_WIDTH, MAP_HEIGHT);
//    stretch_blit(terrain_bmp, HiddenPage, 0, 0, MAP_WIDTH, MAP_HEIGHT, 32, 32, SCREEN_W, SCREEN_H);
	blit(big_map, HiddenPage, 0, 0, 32, 32, SCREEN_W, SCREEN_H);
/*void stretch_blit(BITMAP *source, BITMAP *dest,
int source_x, source_y, source_width, source_height,
int dest_x, dest_y, dest_width, dest_height); */

	// Draw units
//	for (u = units; u; u = u->next)
//		putpixel(HiddenPage, sx + u->x, sy + u->y, 105);

	// Draw projectiles
	for (i = 0; i < active_projectiles; i++)
		if (proj[i].type != PROJ_NONEXISTENT)
			if (BETWEEN(proj[i].x, 0, MAP_WIDTH) && BETWEEN(proj[i].y, 0, MAP_HEIGHT))
				putpixel(HiddenPage, sx + proj[i].x, sy + proj[i].y, makecol(109, 12, 24));	// 42

	// Draw player
//	c = 36 + (simclock % 8);	// 36
	c = simclock % 8;
	c = makecol(190 - c, 56 - c, 64 - c);
	putpixel(HiddenPage, sx + player.x, sy + player.y, c);
	putpixel(HiddenPage, sx + player.x + 1, sy + player.y, c);
	putpixel(HiddenPage, sx + player.x - 1, sy + player.y, c);
	putpixel(HiddenPage, sx + player.x, sy + player.y + 1, c);
	putpixel(HiddenPage, sx + player.x, sy + player.y - 1, c);

	// Draw the player's main base (if they have one.. which they should!)
	if (player.mbase)
	{
		x = player.mbase->x + 2;
		y = player.mbase->y + 2;
//		c = 80 + (simclock % 16);
		c = (simclock % 16) * 2;
		c = makecol(246 - c, 202 - c, 32 - c);
		putpixel(HiddenPage, sx + x, sy + y, c);
		putpixel(HiddenPage, sx + x + 1, sy + y, c);
		putpixel(HiddenPage, sx + x - 1, sy + y, c);
		putpixel(HiddenPage, sx + x, sy + y + 1, c);
		putpixel(HiddenPage, sx + x, sy + y - 1, c);

		putpixel(HiddenPage, sx + x + 1, sy + y + 1, c);
		putpixel(HiddenPage, sx + x - 1, sy + y - 1, c);
		putpixel(HiddenPage, sx + x - 1, sy + y + 1, c);
		putpixel(HiddenPage, sx + x + 1, sy + y - 1, c);
	}

	if (comm_mode != COMM_NONE)
	{
		// Draw enemy players
//		c = 100 + (simclock % 8);
		c = simclock % 8;
		c = makecol(89 - c, 125 - c, 72 - c);
		for (i = 0; i < active_enemies; i++)
		{
			if (enemy[i].comm_state != CS_CONNECTED)
				continue;
			putpixel(HiddenPage, sx + enemy[i].x, sy + enemy[i].y, c);
			putpixel(HiddenPage, sx + enemy[i].x + 1, sy + enemy[i].y, c);
			putpixel(HiddenPage, sx + enemy[i].x - 1, sy + enemy[i].y, c);
			putpixel(HiddenPage, sx + enemy[i].x, sy + enemy[i].y + 1, c);
			putpixel(HiddenPage, sx + enemy[i].x, sy + enemy[i].y - 1, c);
		}
	}
}
