// comm.c: Communications/networking code for Bapple 2.  Created around July of 1997.

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

//#define NDEBUG
#include <assert.h>

//#define RANDOM_PORT

#include <allegro.h>
#include "bap2dat.h"
//#include "dzcomm.h"
//#include "winsock.h"
//#include "bootp.h"
#include "libnet.h"
#include "comm.h"
#include "msg.h"
#include "bapple2.h"
#include "globals.h"
#include "units.h"

//#define Recv nop
//#define Send nop

#ifdef WIN32


#define net_shutdown nop
#define net_initdrivers(a) nop
#define net_loadconfig(a) nop
#define net_init nop
#define net_receive(a, b, c, d) nop()
#define net_query(a) nop
#define delay(a) nop
#define net_openinputchannel(a) nop
#define net_send(a, b, c) nop
#define net_assigntarget(a, b) nop

int nop(void)
{
}

#endif

//unsigned int atoaddr(char *str);
void init_comm(void);
void init_conn(void);
//inline int recv_int(void);
void do_communications(void);
void relay_packet(char *inbuf, int packetlen, int e);
int Send(void *Buffer, int BufferLength, char *Address);
void send_unit_state(unit_t *u);
int playersub(int id);

// From bapple2.c:
extern void zero_timers(void);
extern int create_projectile(float speed, signed char type, signed char team, player_t *ptarget, unit_t *utarget, int x, int y, int xoff, int yoff, int direction);
extern void create_burst(float speed, signed char type, signed char team, int x, int y, int xoff, int yoff);
extern void create_explosion(char type, int x, int y, int xoff, int yoff);
extern int play_sound_vol(SAMPLE *spl, int x, int y, int vol, int pan, int freq, int loop);
extern void add_msg(char type, char *text, ...);
extern void shutdown_system(void);
extern void draw_base(struct BASE_NODE *base);
extern void draw_mbase(struct MBASE_NODE *base);
extern void send_signal(char packet_type);
extern void init_player(void);
extern void page_flip(void);
extern void do_game_drawing(void);
extern void display_info(void);
extern void process_enemy_player_input(int e, signed int *ldir);

// From msg.c:
extern void remap_colors(BITMAP *bmp, PALETTE from, PALETTE to);

// From map.c:
extern int load_map(char *filename);
extern int tileperiodicity;
extern int tileareaw, tileareah;

// From orders.c:
extern unit_t *create_unit(signed char type, int x, int y, int direction, unsigned char owner);


// LIBNET stuff

int WSOCK_PORT = 31337;

char server_addr[80];
char Connect[80];
NET_CHANNEL *s = 0;

unsigned long lastrecvtime = 0;

/* atoaddr(): -------------------------------------------------------------
 *   This handy function will take a string and return a network address.
 *   It will split up an IP address, or resolve a hostname if necessary.
 */
/*unsigned int atoaddr(char *str)
{
	char tmpbuf[40];
	char ip[80];
	int singlenum[4];
	unsigned int i, j, num;
	
// See if this is a hostname or IP address by looking for letters.
	for (i = 0; i < strlen(str); i++)
		if (isalpha(str[i]))
			break;

// If it's a hostname, resolve it
	if (i != strlen(str))
	{
		printf("Attempting to resolve %s...", str);
		BOOTP bootp;
		bootp.op = bootp.op;
		BOOTP_DomainNameServer = dotaddr(205,247,201,2);
		i = Resolve(str);
		if (!i)
		{
			printf("  Sorry, unable to resolve %s!\n", str);
			exit(1);
		}
		printf("  resolved to ");
		PrintIPs(i);
	}
	else
	{
// Split up the IP address (in string form) into its various bytes,
// then attach them all to form the network address int.
		i = 0;
		strcpy(ip, server_addr_str);
		for (num = 0; num < 4; num++)
		{
		    j = 0;
		    while ((ip[i] != '.') && (ip[i] != '\0'))
		        tmpbuf[j++] = ip[i++];
		    tmpbuf[j] = '\0';
		    singlenum[num] = atoi(tmpbuf);
            if ((singlenum[num] > 255) || (!j))
			{
				printf("Sorry, but %s is not a valid IP address.\n", str);
				exit(1);
			}
		    i++;
		}
        i = dotaddr(singlenum[0], singlenum[1], singlenum[2], singlenum[3]);
	}
	return i;
}*/

/* init_comm(): -----------------------------------------------------------
 *   This initializes whatever communications system has been selected.
 */
void init_comm(void)
{

	if (conn_type == CONN_SERIAL)
	{
/*		printf("Initializing comm port...\n");
		comm_port_init();
		LOCK_FUNCTION(serial_wrapper);
	
		if ((serial = comm_port_new(active_port, serial_wrapper)) == NULL)
		{
			dz_print_comm_err();
			exit(1);
		}
		serial->nBoud = _115200;
		sprintf(serial->szName, "COM%d Serial Port", active_port);
		atexit(serial_at_exit);
	
		if (!comm_port_install_handler(serial))
		{
			dz_print_comm_err();
			exit(1);
		} */
	}

	if (conn_type == CONN_WSOCK)
	{
//		SocketInit();
		if (net_init())
		{
			allegro_exit();
			printf("Unable to initialize Libnet!\n");
			exit(1);
		}

		net_loadconfig(NULL);

#ifndef WIN32
		if (!(net_initdrivers(NET_DRIVER_WSOCK) & NET_DRIVER_WSOCK))
#else
		if (1)
#endif
		{
			allegro_exit();
			net_shutdown();
			printf("Unable to initialize the Winsock driver!\n");
			exit(1);
		}
//		if (comm_mode == COMM_CLIENT)
//			strcpy(server_addr, server_addr_str);
//			server_addr = atoaddr(server_addr_str);
	}

}

/* init_conn(): -----------------------------------------------------------
 *   This initiates whatever sort of connection has been selected.
 */

void init_conn(void)
{
	int i;
	PACKET_IREQ_T ireqpacket;
	char buf[256];
	char done;
	struct BASE_NODE *tmpbase;
	struct MBASE_NODE *tmpmbase;
	FILE *fp;

	if (conn_type == CONN_SERIAL)
	{
		printf("Sorry, but serial communications is currently not implemented.  Try wsock.\n");
		exit(1);
	}
	else
	if (conn_type == CONN_WSOCK)
	{
		if (comm_mode == COMM_CLIENT)
		{
			printf("Initiating UDP/IP connection to %s...\n", server_addr);

//			s = new Socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);

			s = net_openinputchannel(NET_DRIVER_WSOCK);

			// Set non-blocking to true
///			i = 1;
///			s->Ioctl(FIONBIO, i);
//			s->_ErrorDisplay = 0;

//		    Connect = (InetAddress) {AF_INET, htons (WSOCK_PORT), server_addr};
			if (!strchr(server_addr, ':'))
				sprintf(Connect, "%s:%d", server_addr, 24785);
			else
				strcpy(Connect, server_addr);

			printf("Sending connection request...");

			buf[0] = PACKET_CREQ;
			Send(&buf[0], 1, Connect);
			delay(600);

			done = 0;
			while ((!done) && (!kbhit()))
			{
//				if (s->Recv (&ireqpacket, sizeof(PACKET_IREQ_T), 0, &Connect, sizeof (InetAddress)))
				if (net_query(s))
				{
					net_receive(s, &ireqpacket, sizeof(PACKET_IREQ_T), Connect);
					if (ireqpacket.type == PACKET_CACK)
						done = 1;
				}
    			else
				{
					delay(1000);
					printf(".");
					buf[0] = PACKET_CREQ;
					Send(&buf[0], 1, Connect);
					delay(200);
				}
			}
			if (kbhit())
			{
				printf("Getting impatient?\n");
				while (kbhit())
					getch();
//				s->Die();
				net_shutdown();
				exit(1);
			}

			// Create an enemy struct for the server, on the client
			active_enemies = 1;
			enemy[0].comm_state = CS_CONNECTED;
			strcpy(enemy[0].name, ireqpacket.name);
			strcpy(enemy[0].addr, Connect);
			fp = fopen("bogus", "w");
			fprintf(fp, "Server is %s: %s", ireqpacket.name, Connect);
			fclose(fp);
			// Set the new client's ID to whatever the server assigned
			player.id = ireqpacket.id;

			// Reset this client's kill and death counts to 0
			player.kills = player.deaths = 0;

			// Reset this client's packet counts to 0
			player.sentpackets = player.recvpackets = player.seqnum = 0;

			// Clear out the map and terrain to water
			memset(map, 0, MAP_WIDTH * MAP_HEIGHT * 2);
			memset(terrain, 0, MAP_WIDTH * MAP_HEIGHT);
			// Nuke the units
			active_units = 0;
			// Get rid of any bases that may have been formed
			while (base)
			{
				tmpbase = base->next;
				free(base);
				base = tmpbase;
			}
			while (mbase)
			{
				tmpmbase = mbase->next;
				free(mbase);
				mbase = tmpmbase;
			}

			game_state = GAME_STATE_INITCONN;

			init_state = 0;

			return;
		}
		else
		if (comm_mode == COMM_SERVER)
		{

#ifdef RANDOM_PORT
			WSOCK_PORT = rand() % 30000;
#endif

/*			printf("Binding to port %d...\n", WSOCK_PORT);
			// Create the listen socket (which is now the main socket)
			s = new Socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);

			// Bind to the port
			InetAddress Bind = (InetAddress) {AF_INET, htons (WSOCK_PORT), 0};
			s->Bind (&Bind, sizeof (InetAddress));
			// Error out if any of this failed
			if (s->_Error)
			{
				printf("Error!  Couldn't bind to port %d- a reboot may be in order.\n", WSOCK_PORT);
				exit(1);
			} */
			printf("Open communications channel...\n");
			s = net_openinputchannel(NET_DRIVER_WSOCK);
			if (s)
				printf("Channel successfully opened.\n");
			else
			{
				printf("Unable to open communications channel!  Try changing ports\n");
				printf("in the network configuration file (libnet.cfg), or rebooting.\n");
				net_shutdown();
				exit(1);
			}
			// Set the server comm state to connected
			player.comm_state = CS_CONNECTED;
			// Grab my IP address - I hope it does the right one!
//			InetAddress Sock;
//			s->GetSockName (&Sock, sizeof (InetAddress));
//			strcpy(player.addr, &Sock, sizeof(InetAddress));
			strcpy(player.addr, "127.0.0.1");	// FIXME

			// Set non-blocking to true
///			i = 1;
///			s->Ioctl(FIONBIO, i);
//			s->_ErrorDisplay = 0;
/*            printf("Listening for a client to connect...\n");
			s->_ErrorDisplay = 0;
			while (((s->Recv (&buf, 4, MSG_PEEK, &Sock, sizeof (InetAddress)) <= 0)) && (!kbhit()))
				delay(100);
			if (kbhit())
			{
				printf("Getting impatient?\n");
                while (kbhit())
					getch();
                s->Die();	// close the port- destructor won't happen on exit()?!
				exit(1);
			}
			Send(&test, sizeof(PACKET), 0, &Sock, sizeof (InetAddress));
			delay(100); */
		}
	}
}

char *maprecvd = 0;		// used for keeping track of which map rows have been recieved
unsigned char pass = 1; // used for passes in the map transmission

void client_initialization(void)
{
	static unsigned long maptime;	// used for timing the map transmission and switching passes
	static unsigned long passtime;	// used for passes in the map transmission
	static int olddatarecvd = 0;
	static unsigned long lastreqtime;
	static char first = 1;
	char buf[500];
	char done;
	int i, j, sent;
	PACKET_IREQ_T ireqpacket;		// initialization request and acknowledge packet
    PACKET_MROWREQ_T rowreq;		// used to request and send map rows
	PACKET_DATAREQ_T datareq;		// used to request data (terrain and map data)
	FILE *fp;
	PALETTE oldpal, thepal;

	if ((ms_time - enemy[0].latency > 8000) && (init_state > 0))
	{
		init_state--;
		enemy[0].latency = ms_time;
	}

			switch (init_state)
			{
				case INIT_SEND_IREQ:
				{
/*                    fp = fopen("error.log", "a");
					fprintf(fp, "Hi. Connect = %p", &Connect);
					fprintf(fp, "\nI want to contact %u.%u.%u.%u",
							(Connect.address) & 0xff,
							(Connect.address >> 8) & 0xff,
							(Connect.address >> 16) & 0xff,
							(Connect.address >> 24) & 0xff);
					fclose(fp);
                    init_state++; */
/*					sprintf(buf, "I want to contact %u.%u.%u.%u",
							(Connect.address) & 0xff,
							(Connect.address >> 8) & 0xff,
							(Connect.address >> 16) & 0xff,
							(Connect.address >> 24) & 0xff);
					add_msg(MSG_COMPUTER, buf);
					init_state++; */
                    ireqpacket.type = PACKET_IREQ;
					strcpy(ireqpacket.name, player.name);
					Send(&ireqpacket, sizeof(PACKET_IREQ_T), Connect);
					sprintf(buf, "Initialization request sent to %s", Connect);
					add_msg(MSG_COMPUTER, buf);
					init_state++;
					break;
				}
				case INIT_RECV_IACK:
				{
					break;	// This step is done in the normal packet receive area
				}
				case INIT_SEND_MHDRREQ:
				{
					add_msg(MSG_COMPUTER, "Requesting map info...");
					buf[0] = PACKET_MAPHDRREQ;
					Send(&buf[0], 1, Connect);
					init_state++;
					break;
				}
				case INIT_RECV_MHDR:
				{
					break;	// This step is done in the normal packet receive area
				}
/*				case INIT_SEND_TERRAINREQ:	// Send a request for another terrain packet
				{
					// If this is the first pass, request the first terrain packet
					if (first)
					{
						first = 0;
						datareq.type = PACKET_TERRAINREQ;
						for (i = 0; i < MAP_WIDTH * MAP_HEIGHT / MAP_PACKET_SIZE; i++)
						{
							datareq.packetnum = i;
							Send(&datareq, sizeof(datareq), 0, &Connect, sizeof (InetAddress));
						}
						lastreqtime = lastrecvtime = ms_time;
						add_msg(MSG_COMPUTER, "Requesting terrain data... (%d packets, %d bytes each)", i, MAP_PACKET_SIZE);
						break;
					}
					// If we've received new data since our last time here, decide what to do
					if (olddatarecvd != datarecvd)
					{
						add_msg(MSG_COMPUTER, "Received %d bytes of data - total so far is %d", datarecvd - olddatarecvd, datarecvd);
//						packetsrecvd += (datarecvd - olddatarecvd) / MAP_PACKET_SIZE;
						olddatarecvd = datarecvd;
						// If we've received enough terrain data that we're done, move on
						if (datarecvd >= MAP_WIDTH * MAP_HEIGHT)
						{
							olddatarecvd = datarecvd = packetsrecvd = 0;	// clean up
							first = 1;									// clean up
							init_state++;
						}
						else	// otherwise ask for more data if nothing has been received lately
						{
							if (ms_time - lastrecvtime > 6000)
							{
								datareq.type = PACKET_TERRAINREQ;
								datareq.packetnum = packetsrecvd;
								Send(&datareq, sizeof(datareq), 0, &Connect, sizeof (InetAddress));
								lastreqtime = ms_time;
								add_msg(MSG_COMPUTER, "Requesting packet #%d", packetsrecvd);
							}
						}
					}
					else	// Otherwise we haven't received data, re-request if stalled..
					{
						if (ms_time - lastreqtime > 5000)	// If we've waited over 5 sec..
						{
							datareq.type = PACKET_TERRAINREQ;
							datareq.packetnum = packetsrecvd;
							Send(&datareq, sizeof(datareq), 0, &Connect, sizeof (InetAddress));
							lastreqtime = ms_time;
							add_msg(MSG_COMPUTER, "Rerequesting packet #%d...", packetsrecvd);
						}
					}
					break;
				} */
/*				case INIT_SEND_MAPREQ:
				{
					init_state++;	// temporarily skip map downloading
					break;
				} */
/*				case INIT_RECV_TERRAIN:
				{
//					send_signal();
					break;
				}
				case INIT_RECV_MAP:
				{
					if (!maprecvd)
					{
						maprecvd = (char *) calloc(MAP_HEIGHT, 1);
						maptime = passtime = ms_time;
					}

                    for (i = 0; i < MAP_HEIGHT; i++)
					{
						if (maprecvd[i] == 0)		// If we haven't requested a row...
						{
							rowreq.type = PACKET_MAPROWREQ;

							for (j = 0; j < 5; j++)
							{
	                            maprecvd[(i + j)] = 1;
								rowreq.row = i + j;
								if ((i + j) < MAP_HEIGHT)
								{
									maprecvd[(i + 1)] = 1;
									Send(&rowreq, sizeof(PACKET_MROWREQ_T), 0, &Connect, sizeof (InetAddress));
								}
							}
                            sprintf(buf, "Requesting rows %d through %d", j + i - 5, j + i);
							add_msg(MSG_COMPUTER, buf);

							passtime = ms_time;
							break;
						}
						else if (maprecvd[i] == 1)
							break;
					}
					if (ms_time - passtime > 1000)
						for (i = 0; i < MAP_HEIGHT; i++)
							if (maprecvd[i] == 1)
							{
								maprecvd[i] = 0;
								break;
							}
					done = 1;
					for (i = 0; i < MAP_HEIGHT; i++)
						if (maprecvd[i] != 100)
							done = 0;
					if (done)
					{
						sprintf(buf, "Map received- %d bytes in %.2f seconds, %.1f cps",
								MAP_WIDTH * MAP_HEIGHT * 3,
								((float) (ms_time - maptime)) / 1000.0,
								((float) (MAP_WIDTH * MAP_HEIGHT * 3)) / ((float) (((float) (ms_time - maptime)) / 1000.0)));
						add_msg(MSG_COMPUTER, buf);
						init_state++;
                        free(maprecvd);

						// Aiee, this is awful - code for loading a tileset and palette..

						if (!tilefile[0])
							add_msg(MSG_COMPUTER, "(using internal tileset)");
						else
						{
							unload_datafile(terraingfx);
							terraingfx = load_datafile(tilefile);
							if (terraingfx)
								add_msg(MSG_COMPUTER, "(using tileset %s)", tilefile);
							else
							{
								strcat(tilefile, ".dat");
								terraingfx = load_datafile(tilefile);
								if (terraingfx)
									add_msg(MSG_COMPUTER, "(using tileset %s)", tilefile);
								else
								{
									add_msg(MSG_COMPUTER, "Unable to load requested tileset %s!", tilefile);
									tilefile[0] = '\0';
								}
							}
							// Search the datafile for a palette to load
							j = 0;
							for (i = 0; terraingfx[i].type != DAT_END; i++)
								if (terraingfx[i].type == DAT_PALETTE)
								{
									get_palette(oldpal);
					                set_palette((RGB *) terraingfx[i].dat);
									get_palette(thepal);
									j = 1;
									break;
								}
							if (!j)
							{
								add_msg(MSG_COMPUTER, "Error: Loaded tile datafile %s, but it didn't have a palette", tilefile);
								tilefile[0] = '\0';
								unload_datafile(terraingfx);
								terraingfx = 0;
							}
							else  // Search the datafile for bitmaps to have their palettes remapped
							{
								j = 0;
				                for (i = 0; datafile[i].type != DAT_END; i++)
									if (datafile[i].type == DAT_BITMAP)
									{
										remap_colors((BITMAP *) datafile[i].dat, oldpal, thepal);
										j++;
									}
				
								tileperiodicity = 16;
								tileareaw = 16;
								tileareah = 28;
				
								add_msg(MSG_COMPUTER, "Loaded tile datafile %s, remapped %d bitmaps", tilefile, j);
							}
						}
					}
					break;
				} */
				case INIT_SEND_BASEREQ:
				{
					add_msg(MSG_COMPUTER, "Requesting base information...");
					buf[0] = PACKET_BASEREQ;
					Send(&buf[0], 1, Connect);
					init_state++;
					break;
				}
				case INIT_RECV_BASES:
				{
					break;  // This step is done in the normal packet receive area
				}
				case INIT_SEND_MBASEREQ:
				{
					add_msg(MSG_COMPUTER, "Requesting main base information...");
					buf[0] = PACKET_MBASEREQ;
					Send(&buf[0], 1, Connect);
					init_state++;
					break;
				}
				case INIT_RECV_MBASES:
				{
					break;  // This step is done in the normal packet receive area
				}
				case INIT_SEND_UNITREQ:
				{
					add_msg(MSG_COMPUTER, "Requesting unit information...");
					buf[0] = PACKET_UNITREQ;
					Send(&buf[0], 1, Connect);
					init_state++;
					break;
				}
				case INIT_RECV_UNITS:
				{
					break;  // This step is done in the normal packet receive area
				}
				case INIT_SEND_CLREQ:
				{
					add_msg(MSG_COMPUTER, "Requesting information about other players...");
					buf[0] = PACKET_CLREQ;
					Send(&buf[0], 1, Connect);
					init_state++;
					break;
				}
				case INIT_RECV_CLIENTS:
				{
					break;  // This step is done in the normal packet receive area
				}
				case INIT_START_GAME:
				{
					init_state = 0;	// experimental, added to try and fix "Unknown 14" @ school
					game_state = GAME_STATE_PLAY;
                    // Flash the screen and respawn the player
					play_sample((SAMPLE *) datafile[SND_SPAWN].dat, 255, 128, 1000, FALSE);
					send_signal(PACKET_REGEN);
					fade_from((RGB *) datafile[MAIN_PAL].dat, whitepal, 16);
					init_player();
					player.speed = 0;
					do_game_drawing();
					display_info();
					page_flip();
					fade_from(whitepal, (RGB *) datafile[MAIN_PAL].dat, 16);
					break;
				}
				default:
				{
					add_msg(MSG_COMPUTER, "Dangerous error: Unknown initialization state %d!  Attempting to go right into game play..\n", init_state);
					init_state = INIT_START_GAME;
//					init_state = 0;
//					game_state = GAME_STATE_PLAY;
/*					set_gfx_mode(GFX_TEXT, 80, 25, 0, 0);
					printf("Fatal error: Unknown initialization state %d!\n", init_state);
					readkey();
					exit(1); */
				}
			}
}

//char *inbuf = 0;
//char *buf = 0;
char inbuf[4000];
char buf[4000];
unit_t *unit_address[1000][2];

void process_packet(char type, int packetlen, int e)
{
	int i, j, k;
	unit_t *u, *tmpu;
	int victim, victor;
	PACKET_IREQ_T ireqpacket;		// initialization request and acknowledge packet
    PACKET_MHDR_T mapheader;		// map header, used in the map transmission
    PACKET_MROWREQ_T rowreq;		// used to request and send map rows
	PACKET_HURT_T hurtpacket;		// used to do hurt requests
	PACKET_DATAREQ_T datareq;		// used for data requests (terrain and map data)
	PACKET_PROJ_T projdata;			// used for projectile creation requests
	PACKET data;
	struct BASE_NODE *newbase;
	struct MBASE_NODE *newmbase;
	static int reject = 0;			// Number of rejected (unknown) packets
	static char recvd_server = 0;	// Has the new client received a server info packet yet?
	FILE *fp;
	char tmpaddr[80];
	unit_t tmpunit;
	thing_t *tmpthing;

	switch (type)
	{
// Server-side initialization packets
		case PACKET_CREQ:
		{
			sprintf(buf, "Someone from %s requested a new connection.", Connect);
			add_msg(MSG_COMPUTER, buf);
			break;
		}
		case PACKET_IREQ:
		{
			sprintf(buf, "Received initialization request from %s", Connect);
			add_msg(MSG_COMPUTER, buf);
			memcpy(&ireqpacket, &inbuf, sizeof(PACKET_IREQ_T));
			// Grab the enemy's name and put it in their struct
			strcpy(enemy[e].name, ireqpacket.name);
			// Tell the other guys about the new player
			for (i = 0; i < active_enemies; i++)
			{
				if (enemy[i].comm_state != CS_CONNECTED)
					continue;
				buf[0] = PACKET_MSG;
				sprintf(&buf[1], "%s from %s is connecting...", ireqpacket.name, Connect);
				Send(&buf[0], strlen(buf), enemy[i].addr);
			}
			// Tell the server the new player's name
			sprintf(buf, "%s from %s is connecting...",ireqpacket.name, Connect);
			add_msg(MSG_COMPUTER, buf);
			// Acknowledge the IREQ with an IACK
			buf[0] = PACKET_IACK;
			Send(&buf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_MAPHDRREQ:
		{
			sprintf(buf, "Sending map info to %s...", enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
			mapheader.type = PACKET_MAPHDR;
			mapheader.width = MAP_WIDTH;
			mapheader.height = MAP_HEIGHT;
			strcpy(mapheader.filename, current_map_filename);
			Send(&mapheader, sizeof(PACKET_MHDR_T), enemy[e].addr);
			break;
		}
		case PACKET_TERRAINREQ:
		{
			memcpy(&datareq, &inbuf, sizeof(PACKET_DATAREQ_T));
			add_msg(MSG_COMPUTER, "%s requested packet #%d...", enemy[e].name, datareq.packetnum);
			datareq.type = PACKET_TERRAIN;
//			memcpy(&buf[1], &datareq.packetnum, sizeof(datareq.packetnum));
			memcpy(&buf[0], &datareq, sizeof(PACKET_DATAREQ_T));
			memcpy(&buf[sizeof(PACKET_DATAREQ_T)], &terrain[datareq.packetnum * MAP_PACKET_SIZE], MAP_PACKET_SIZE);
			Send(&buf[0], sizeof(PACKET_DATAREQ_T) + MAP_PACKET_SIZE, enemy[e].addr);
			break;
		}
/*		case PACKET_MAPROWREQ:
		{
			memcpy(&rowreq, &inbuf, sizeof(PACKET_MROWREQ_T));
			rowreq.type = PACKET_MAPROW;
			memcpy(&buf[0], &rowreq, sizeof(PACKET_MROWREQ_T));
			memcpy(&buf[sizeof(PACKET_MROWREQ_T)], &map[(MAP_WIDTH * rowreq.row)], MAP_WIDTH * 2);	// formerly no * 2 here
			memcpy(&buf[(MAP_WIDTH + sizeof(PACKET_MROWREQ_T))], &terrain[(MAP_WIDTH * rowreq.row)], MAP_WIDTH);
			add_msg(MSG_COMPUTER, "Sending row %d (%d bytes starting at %d)", rowreq.row, MAP_WIDTH * 2, MAP_WIDTH * rowreq.row * 2);
			Send(&buf[0], ((MAP_WIDTH * 2) + sizeof(PACKET_MROWREQ_T)), 0, &enemy[e].addr, sizeof (InetAddress));
			break;
		} */
		case PACKET_BASEREQ:
		{
			sprintf(buf, "Sending bases to %s...", enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
			// Send all of the base data in one burst (should be just fine)
			for (newbase = base; newbase != NULL; newbase = newbase->next)
			{
				buf[0] = PACKET_BASE;
				memcpy(&buf[1], newbase, sizeof(struct BASE_NODE));
				Send(&buf[0], sizeof(struct BASE_NODE) + 1, enemy[e].addr);
			}
			// Signal the end of the bases by an empty base packet
			buf[0] = PACKET_BASE;
			Send(&buf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_MBASEREQ:
		{
			sprintf(buf, "Sending main-bases to %s...", enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
			// Send all of the main-base data in one burst (should be just fine)
			for (newmbase = mbase; newmbase; newmbase = newmbase->next)
			{
				buf[0] = PACKET_MBASE;
				memcpy(&buf[1], newmbase, sizeof(struct MBASE_NODE));
				Send(&buf[0], sizeof(struct MBASE_NODE) + 1, enemy[e].addr);
			}
			// Signal the end of the main-bases by an empty base packet
			buf[0] = PACKET_MBASE;
			Send(&buf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_UNITREQ:
		{
			sprintf(buf, "Sending units to %s...", enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
			// Send all of the unit data in one burst (should be just fine)
			for (u = units; u; u = u->next)
			{
				buf[0] = PACKET_UNIT;
				memcpy(&buf[1], u, sizeof(unit_t));		// unit data
				memcpy(&buf[1 + sizeof(unit_t)], &u, sizeof(unit_t *));	// unit pointer
				Send(&buf[0], 1 + sizeof(unit_t) + sizeof(unit_t *), enemy[e].addr);
			}
			// Signal the end of the units by an empty unit packet
			buf[0] = PACKET_UNIT;
			Send(&buf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_CLREQ:
		{
			// Send complete data about the server
			buf[0] = PACKET_CLIENT;
			memcpy(&buf[1], &player, sizeof(player_t));
			Send(&buf[0], sizeof(player_t) + 1, enemy[e].addr);
			j = 1;
			// Send all of the enemy data in one burst (should be just fine)
			for (i = 0; i < active_enemies; i++)
			{
				if ((enemy[i].comm_state != CS_CONNECTED) || (i == e))
					continue;
				buf[0] = PACKET_CLIENT;
				memcpy(&buf[1], &enemy[i], sizeof(player_t));
				Send(&buf[0], sizeof(player_t) + 1, enemy[e].addr);
				j++;
			}
			sprintf(buf, "Sending information to %s about %d player%c...", enemy[e].name, j, (j > 1) ? 's' : '.');
			add_msg(MSG_COMPUTER, buf);
			// Signal the end of the enemy data by an empty client packet
			buf[0] = PACKET_CLIENT;
			Send(&buf[0], 1, enemy[e].addr);
			// Give the new client a ship based on their ID number
			enemy[e].shiptype = enemy[e].id;
			enemy[e].shiptype %= num_ship_types;
			// The new client is ready to rock
			enemy[e].comm_state = CS_CONNECTED;
			// Notify all the other players of this new client
			buf[0] = PACKET_CLIENT;
			memcpy(&buf[1], &enemy[e], sizeof(player_t));
			for (i = 0; i < active_enemies; i++)
			{
				if ((enemy[i].comm_state == CS_NONEXISTENT) || (i == e))
					continue;
				Send(&buf[0], sizeof(player_t) + 1, enemy[i].addr);
			}
			sprintf(buf, "%s has entered the game.", enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
			break;
		}
// Client-side initialization packets
		case PACKET_IACK:
		{
			if (init_state == INIT_RECV_IACK)
			{
				sprintf(buf, "Initialize request acknowledged by %s.", enemy[0].name);
				add_msg(MSG_COMPUTER, buf);
				init_state++;
			}
			break;
		}
		case PACKET_MAPHDR:
		{
			if (init_state == INIT_RECV_MHDR)
			{
				memcpy(&mapheader, &inbuf, sizeof(PACKET_MHDR_T));
				load_map(mapheader.filename);
/*				MAP_WIDTH = mapheader.width;
				MAP_HEIGHT = mapheader.height;
				if (mapheader.tilefile[0])
					sprintf(buf, "Receiving %dx%d map using tileset %s...", MAP_WIDTH, MAP_HEIGHT, mapheader.tilefile);
				else
					sprintf(buf, "Receiving %dx%d map using internal tileset...", MAP_WIDTH, MAP_HEIGHT);
				strcpy(tilefile, mapheader.tilefile); */
				add_msg(MSG_COMPUTER, "Using map %s: %s created by %s\n",
						current_map_filename, current_map.name, current_map.author);
				init_state++;
			}
			break;
		}
/*		case PACKET_TERRAIN:
		{
			if (init_state == INIT_SEND_TERRAINREQ)
			{
				lastrecvtime = ms_time;
				memcpy(&datareq, &inbuf, sizeof(PACKET_DATAREQ_T));
				if (datareq.packetnum != packetsrecvd)
					add_msg(MSG_COMPUTER, "Warning: Expected packet #%d, got #%d", packetsrecvd, datareq.packetnum);
				else
				{
					add_msg(MSG_COMPUTER, "Received packet #%d", packetsrecvd);
					packetsrecvd++;
					datarecvd += MAP_PACKET_SIZE;
				}
				memcpy(&terrain[datareq.packetnum * MAP_PACKET_SIZE], &buf[sizeof(PACKET_DATAREQ_T)], MAP_PACKET_SIZE);
				redraw_terrain_bmp = 1;
			}
			break;
		} */
/*				case PACKET_MAPROW:
		{
			if (init_state == INIT_RECV_MAP)
			{
                   memcpy(&rowreq, &inbuf, sizeof(PACKET_MROWREQ_T));
				memcpy(&map[(MAP_WIDTH * rowreq.row)], &inbuf[sizeof(PACKET_MROWREQ_T)], MAP_WIDTH * 2);	// formerly no * 2 here
				memcpy(&terrain[(MAP_WIDTH * rowreq.row)], &inbuf[(MAP_WIDTH + sizeof(PACKET_MROWREQ_T))], MAP_WIDTH);
				maprecvd[rowreq.row] = 100;
				add_msg(MSG_COMPUTER, "Received row %d (%d bytes starting at %d)", rowreq.row, MAP_WIDTH * 2, MAP_WIDTH * rowreq.row * 2);
				redraw_terrain_bmp = 1;
			}
			break;
		} */
		case PACKET_BASE:
		{
			if (init_state == INIT_RECV_BASES)
			{
				if (packetlen > 1)	// If this is a real base
				{
					newbase = (struct BASE_NODE *) calloc(1, sizeof(struct BASE_NODE));
					memcpy(newbase, &inbuf[1], sizeof(struct BASE_NODE));
					// Insert node into global base list (at beginning)
					newbase->next = base;
					base = newbase;
					// Draw the new base onto the map
					draw_base(newbase);
				}
				else				// Otherwise it's a signal of the end
				{
					add_msg(MSG_COMPUTER, "Received base information.");
					init_state++;
				}
			}
			break;
		}
		case PACKET_MBASE:
		{
			if (init_state == INIT_RECV_MBASES)
			{
				if (packetlen > 1)	// If this is a real main-base
				{
					newmbase = (struct MBASE_NODE *) calloc(1, sizeof(struct MBASE_NODE));
					memcpy(newmbase, &inbuf[1], sizeof(struct MBASE_NODE));
//					sprintf(buf, "Received main-base with health: %d...", newmbase->health);
//					add_msg(MSG_COMPUTER, buf);
					// Insert node into global main-base list (at beginning)
					newmbase->next = mbase;
					mbase = newmbase;
					// Draw the base onto the maps (visible and terrain)
					draw_mbase(newmbase);
					// Give the new player a neutral main-base
//					if (newmbase->owner == NEUTRAL)
					// Welcome the player to their new main-base
					if (newmbase->owner == player.id)
					{
						newmbase->owner = player.id;
						player.mbase = newmbase;
						player.x = player.mbase->x + 2;
						player.y = player.mbase->y + 2;
					}
				}
				else				// Otherwise it's a signal of the end
				{
					add_msg(MSG_COMPUTER, "Received main-base information.");
					init_state++;
				}
			}
			break;
		}
		case PACKET_UNIT:
		{
			if (init_state == INIT_RECV_UNITS)
			{
				if (packetlen > 1)	// If this is a real unit and not the ending signal
				{
					u = create_unit(0, 0, 0, 0, 0);
					tmpu = u->next;
					memcpy(u, &inbuf[1], sizeof(unit_t));	// Get the unit data
					memcpy(&unit_address[active_units][0], &inbuf[1 + sizeof(unit_t)], sizeof(unit_t *));	// Get the remote pointer
					unit_address[active_units][1] = u;	// Save the local address
					u->next = tmpu;
					u->target = NULL;	// UFIXME!!!  Must preserve targets...

					if (u->path)
					{
						desired_terrain = unit_terrain[u->type];
						u->path = (struct NODE *) FindPath((long)u->dx,(long)u->dy,(long)u->x,(long)u->y);
						u->OPEN = OPEN;
						u->CLOSED = CLOSED;
					}

					add_msg(MSG_EXPENDABLE, "Received unit #%d", active_units);
					active_units++;
				}
				else				// Otherwise it's a signal of the end
				{
					add_msg(MSG_COMPUTER, "Received unit information for %d units.", active_units);
					init_state++;

					// Fix the target pointers using the unit_address table
/*					for (i = 0; i < active_units; i++)
					{
                        for (j = 0; j < active_units; j++)
						{
							if (unit_address[j][0] == unit_address[i][1]->target)
							{
								unit_address[i][1]->target = unit_address[j][1];
								break;
							}
						}
						if (j == active_units)
							add_msg(MSG_COMPUTER, "Warning: Unable to match unit %p's target: %p", unit_address[i][1], unit_address[i][1]->target);
					} */
				}
			}
			break;
		}
		case PACKET_CLIENT:
		{
			if (packetlen > 1)	// If this is a real client
			{
				if ((game_state == GAME_STATE_INITCONN) || (comm_mode == COMM_SERVER))
				{
					if ((comm_mode == COMM_CLIENT) && (!recvd_server))	// if this is the 1st client packet..
					{
						active_enemies = 0;	// it's really the server (this gets incremented below)
						recvd_server = 1;
						strcpy(tmpaddr, enemy[0].addr);	// save the server address
						memcpy(&enemy[active_enemies++], &inbuf[1], sizeof(player_t));
						strcpy(enemy[0].addr, tmpaddr);
					}
					else	// Otherwise it is the client sending their info to the server
						memcpy(&enemy[active_enemies++], &inbuf[1], sizeof(player_t));
					// Display a message telling who we received info about
					i = active_enemies - 1;
					sprintf(buf, "Received info about %s (ID %d) from %s",
							enemy[i].name, enemy[i].id, enemy[i].addr);
					add_msg(MSG_COMPUTER, buf);
				}
				else	// we are a client in the game receiving info about a new client
				{
					for (i = 0; i < active_enemies; i++)
						if (enemy[i].comm_state == CS_NONEXISTENT)
							break;
					if (i == active_enemies)
						i = active_enemies++;
					memcpy(&enemy[i], &inbuf[1], sizeof(player_t));
					sprintf(buf, "%s from %s has entered the game.", enemy[i].name, enemy[i].addr);
					add_msg(MSG_COMPUTER, buf);
				}
			}
			else				// Otherwise it's a signal of the end
			{
				sprintf(buf, "Received enemy information about %d enemies.", active_enemies);
				add_msg(MSG_COMPUTER, buf);
				init_state++;
			}
			break;
		}
// Normal game packets
		case PACKET_PLSTATE:
		{
			memcpy(&data, &inbuf, sizeof(PACKET));
			relay_packet((char *) &data, sizeof(PACKET), e);	// FIXME - can't just relay everything!
			for (i = 0; i < active_enemies; i++)
				if ((enemy[i].comm_state != CS_NONEXISTENT) && (enemy[i].id == data.id))
				{
					enemy[i].x = data.x;
					enemy[i].y = data.y;
					enemy[i].xoff = data.xoff;
					enemy[i].yoff = data.yoff;
					enemy[i].direction = data.direction;
					enemy[i].speed = data.speed;
					enemy[i].health = data.health;
					enemy[i].input = data.input;
					if (debug)
		                textprintf(VisiblePage, font, 64, 100, TEXT_COLOR, "Recv from %s ID=%d", enemy[i].name, data.id);
                          break;
				}
			if ((i == active_enemies) && (debug))
                textprintf(VisiblePage, font, 64, 100, TEXT_COLOR, "Recv from ??? ID=%d", data.id);
			break;
		}
		case PACKET_USTATE:
		{
			relay_packet(&inbuf[0], sizeof(unit_t) + 1, e);
			memcpy(&tmpunit, &inbuf[1], sizeof(unit_t));
			if (debug)
				add_msg(MSG_EXPENDABLE, "Got ustate %d for %s's #%d", tmpunit.orders, enemy[playersub(tmpunit.owner)].name, tmpunit.id);
			for (u = units; u; u = u->next)
				if (u->id == tmpunit.id)
					break;

			// If someone just picked up this unit
			if ((u->carrier == -1) && (tmpunit.carrier != -1))
			{
				if (debug)
					add_msg(MSG_COMPUTER, "Enemy picked up a unit");
				for (i = 0; i < active_enemies; i++)
					if (enemy[i].id == tmpunit.carrier)
					{
						enemy[i].unit_carried = u;
						if (debug)
							add_msg(MSG_COMPUTER, "Found enemy picked up unit");
						break;
					}
			}
			else	// If someone just dropped off this unit
			if ((u->carrier != -1) && (tmpunit.carrier == -1))
				for (i = 0; i < active_enemies; i++)
					if (enemy[i].id == u->carrier)
					{
						if (debug)
							add_msg(MSG_COMPUTER, "%s dropped unit #%d", enemy[i].name, tmpunit);
						enemy[i].unit_carried = NULL;
						break;
					}

			// If the local unit has a path, destroy it
			if (u->path)
				free_path_nodes(u);

			// Update the local unit state
			tmpu = u->next;
			memcpy(u, &inbuf[1], sizeof(unit_t));	// Get the unit data
			u->next = tmpu;
			u->target = NULL;	// UFIXME!!!  Should preserve targets...

			// Take care of path recalculation
			if (u->path)
			{
				desired_terrain = unit_terrain[u->type];
				// If they're guarding, calculate a path for em
				// First their tile must not be marked in unit_at though!
				tmpthing = mpos(unit_at, u->y, u->x);
				mpos(unit_at, u->y, u->x) = 0;
				u->path = (struct NODE *) FindPath((long)u->dx,(long)u->dy,(long)u->x,(long)u->y);
				u->OPEN = OPEN;
				u->CLOSED = CLOSED;
				// Now the unit tile can be remarked as being occupied
				mpos(unit_at, u->y, u->x) = tmpthing;
			}
			break;
		}
		case PACKET_UKILL:
		{
			relay_packet(&inbuf[0], packetlen, e);
			j = 0;
			for (u = units; u; u = u->next)
				if (u->id == *(long *)(inbuf + 1))
				{
					if (debug)
						add_msg(MSG_COMPUTER, "Got ukill for %s's #%d, health = %d", enemy[playersub(tmpunit.owner)].name, tmpunit.id, u->health);
					if (u->health > 0)	// don't make explosions for units already dying/dead
					{
		                create_explosion(BIG_EXPLOSION, u->x, u->y, u->xoff - 8, u->yoff - 8);
						play_sound_vol((SAMPLE *) datafile[SND_EXPLOSION].dat, u->x, u->y, 128, 128, 1000 + (rand() % 400) - 200, FALSE);
						destroy_unit(u);
					}
					break;
				}
			break;
		}
		case PACKET_PROJ:
		{
			memcpy(&projdata, &inbuf, sizeof(PACKET_PROJ_T));
			relay_packet((char *) &projdata, sizeof(PACKET_PROJ_T), e);
			i = create_projectile(fixtof(projdata.speed), projdata.ptype, projdata.id, 0, 0, (int) projdata.x, (int) projdata.y, (int) projdata.xoff, (int) projdata.yoff, (int) projdata.direction);

			// Set up the player target pointer
			if (projdata.ptarget != -1)
			{
				if (projdata.ptarget == player.id)
					proj[i].ptarget = &player;
				else
					for (j = 0; j < active_enemies; j++)
						if (enemy[j].id == projdata.ptarget)
						{
							proj[i].ptarget = &enemy[j];
							break;
						}
			}

			// Set up the unit target pointer
			if (projdata.utarget != -1)
				for (u = units; u; u = u->next)
					if (u->id == projdata.utarget)
					{
						proj[i].utarget = u;
						break;
					}

			if (debug)
				textprintf(VisiblePage, font, 64, 100, TEXT_COLOR, "Recv: projectile");
			break;
		}
		case PACKET_BURST:
		{
			memcpy(&data, &inbuf, sizeof(PACKET));
			relay_packet((char *) &data, sizeof(PACKET), e);
			create_burst(fixtof(data.speed), PROJECTILE_TYPE_YELLOW, data.id, (int) data.x, (int) data.y, (int) data.xoff, (int) data.yoff);
			if (debug)
				textprintf(VisiblePage, font, 64, 100, TEXT_COLOR, "Recv: burst");
			break;
		}
		case PACKET_PING:
		{
			buf[0] = PACKET_PONG;
			Send(&buf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_PONG:
		{
			add_msg(MSG_COMPUTER, "Ping response from %s: %dms", enemy[e].name, ms_time - enemy[e].pingtime);
			break;
		}
		case PACKET_NEWUNIT:
		{
			relay_packet(&inbuf[0], sizeof(unit_t) + 1, e);
			u = create_unit(0, 0, 0, 0, 0);
			tmpu = u->next;
			memcpy(u, &inbuf[1], sizeof(unit_t));	// Get the unit data
			u->next = tmpu;
			u->target = NULL;	// UFIXME!!!  Should preserve targets...

			if (u->path)
			{
				desired_terrain = unit_terrain[u->type];
				tmpthing = mpos(unit_at, u->y, u->x);
				mpos(unit_at, u->y, u->x) = 0;
				u->path = (struct NODE *) FindPath((long)u->dx,(long)u->dy,(long)u->x,(long)u->y);
				u->OPEN = OPEN;
				u->CLOSED = CLOSED;
				mpos(unit_at, u->y, u->x) = tmpthing;
			}

			// If this unit is being carried, set the carrier's unit_carried property
			if (u->carrier != -1)
				for (i = 0; i < active_enemies; i++)
					if (enemy[i].id == u->carrier)
					{
						enemy[i].unit_carried = u;
						break;
					}

			// Find the owner for message display purposes
			for (i = 0; i < active_enemies; i++)
				if (enemy[i].id == u->owner)
					break;
			if (i == active_enemies)
				add_msg(MSG_COMPUTER, "An unknown player has created a %s with ID #%d", unit_name[u->type], u->id);
			else
				add_msg(MSG_COMPUTER, "%s has created a %s with ID #%d", enemy[i].name, unit_name[u->type], u->id);
			break;
		}
		case PACKET_MSG:
		{
			relay_packet(&inbuf[0], packetlen, e);
			play_sample((SAMPLE *) datafile[SND_TALK].dat, 255, 128, 1000 + (rand() % 100) - 50, FALSE);
			add_msg(MSG_ENEMY, &inbuf[1]);
			break;
		}
		case PACKET_HIGH:
		{
//			add_msg(MSG_COMPUTER, "Received request for high-frequency sending.");
			send_frequency = HIGH_FREQ;
			ms_send = HIGH_FREQ + 1;
			break;
		}
		case PACKET_LOW:
		{
//			add_msg(MSG_COMPUTER, "Received request for low-frequency sending.");
			send_frequency = LOW_FREQ;
			ms_send = LOW_FREQ + 1;
			break;
		}
		case PACKET_HURT:
		{
			memcpy(&hurtpacket, &inbuf, sizeof(PACKET_HURT_T));
			if (debug)
				add_msg(MSG_COMPUTER, "Hurtpacket, victor ID = %d  Victim ID = %d", hurtpacket.victor, hurtpacket.victim);
			// Match an ID number with an enemy subscript number
/*			for (i = 0; i < active_enemies; i++)
				if (enemy[i].comm_state == CS_CONNECTED)
					if (enemy[i].id == hurtpacket.victim) // This is who is getting hurt
						break;
			if (i == active_enemies)
			{
				sprintf(buf, "Warning: Received hurt request for unknown ID %d", hurtpacket.id);
				add_msg(MSG_COMPUTER, buf);
				break;
			}
			sprintf(buf, "Received hurt request from %s for %s", enemy[e].name, enemy[j].name);
			add_msg(MSG_COMPUTER, buf); */
			if (comm_mode == COMM_CLIENT)
			{
				if (!invincible)
				{
					if (player.health > 0)
					{
						if (debug)
							add_msg(MSG_COMPUTER, "Client hit, player.lastattacker = %d", hurtpacket.victor);
						player.lastattacker = hurtpacket.victor;
						player.health -= hurtpacket.health;
					}
				}
			}
			else if (comm_mode == COMM_SERVER)
			{
				if ((hurtpacket.victim == 0) && (!invincible))
				{
					if (player.health > 0)
					{
						if (debug)
							add_msg(MSG_COMPUTER, "Server hit, player.lastattacker = %d", hurtpacket.victor);
						player.lastattacker = hurtpacket.victor;
						player.health -= hurtpacket.health;
					}
				}
				else
					Send(&hurtpacket, sizeof(PACKET_HURT_T), enemy[hurtpacket.victim].addr);
			}
			if (debug)
                   textprintf(VisiblePage, font, 64, 100, TEXT_COLOR, "Recv: hurt request from %d for %d", hurtpacket.victim, hurtpacket.victor);
			break;
		}
		case PACKET_DEATH:
		{
			relay_packet(&inbuf[0], packetlen, e);
			victim = inbuf[1];
			victor = inbuf[2];
			j = k = 200;
			// Match IDs from the 1st (victim) and 2nd (victor) bytes of the death packet
			for (i = 0; i < active_enemies; i++)
			{
				if (enemy[i].comm_state != CS_CONNECTED)
					continue;
				if (enemy[i].id == victim)
					j = i;
				if (enemy[i].id == victor)
					k = i;
			}
			// j is the victim, k is the victor.  Adjust their scores.

			// Process the victim stats changing
			if (victim == player.id)	// If YOU died...
			{
				player.deaths++;
				if (k == 200)
				{
					if (victor == PROJECTILE_TEAM_UNIT)
						add_msg(MSG_DEATH, "You were killed by a unit!");
					else
					{
						sprintf(buf, "You were killed by an unknown player with ID %d!", victor);
						add_msg(MSG_DEATH, buf);
					}
				}
				else
				{
					sprintf(buf, "You were killed by %s!", enemy[k].name);
					add_msg(MSG_DEATH, buf);
					enemy[k].kills++;
				}
			}
			else	// otherwise someone else died...
			{
				if (j != 200)
				{
					enemy[j].deaths++;
					// If we killed em...
					if (victor == player.id)
					{
						sprintf(buf, "You killed %s!", enemy[j].name);
						add_msg(MSG_DEATH, buf);
						player.kills++;
					}
					else	// otherwise someone else killed em
					{
						if (k == 200)
						{
							if (victor == PROJECTILE_TEAM_UNIT)
							{
								sprintf(buf, "%s was killed by a unit!", enemy[j].name);
								add_msg(MSG_DEATH, buf);
							}
							else
							{
								sprintf(buf, "%s was killed by an unknown player with ID %d!", enemy[j].name, victor);
								add_msg(MSG_DEATH, buf);
							}
						}
						else
						{
                            sprintf(buf, "%s was killed by %s!", enemy[j].name, enemy[k].name);
							add_msg(MSG_DEATH, buf);
							enemy[k].kills++;
						}
					}
				}
				else
				{
					sprintf(buf, "Warning: unknown death victim with ID %d", j);
					add_msg(MSG_COMPUTER, buf);
				}
			}

			create_explosion(BIG_EXPLOSION, enemy[j].x, enemy[j].y, enemy[j].xoff, enemy[j].yoff);
			play_sound_vol((SAMPLE *) datafile[SND_LONGEXPLOSION].dat, enemy[j].x, enemy[j].y, 255, 128, 1000 + (rand() % 400) - 200, FALSE);
			enemy[e].hidden = 1;
			break;
		}
		case PACKET_REGEN:
		{
			relay_packet(&inbuf[0], packetlen, e);
			memcpy(&data, &inbuf[0], packetlen);
			play_sound_vol((SAMPLE *) datafile[SND_SPAWN].dat, enemy[e].x, enemy[e].y, 128, 128, 1000, FALSE);
			enemy[e].hidden = 0;
			break;
		}
		case PACKET_KPALIVE:
		{
			if (comm_mode == COMM_CLIENT)
				Send(&inbuf[0], 1, enemy[e].addr);
			break;
		}
		case PACKET_EXIT:
		{
			if (enemy[e].comm_state != CS_NONEXISTENT)
			{
				sprintf(buf, "%c%s has left the game.", PACKET_MSG, enemy[e].name);
				add_msg(MSG_COMPUTER, &buf[1]);
				relay_packet(&buf[0], strlen(buf) - 1, e);
				buf[0] = PACKET_KILLCL;
				buf[1] = enemy[e].id;
				relay_packet(&buf[0], 2, e);
				enemy[e].comm_state = CS_NONEXISTENT;
			}
			break;
		}
		case PACKET_KILLCL:
		{
			add_msg(MSG_COMPUTER, "Received KILLCL request for player #%d", inbuf[1]);
			relay_packet(&inbuf[0], packetlen, e);
			if ((player.id == inbuf[1]) && (comm_mode != COMM_SERVER))
				game_state = GAME_STATE_EXIT;
			else
			for (i = 0; i < active_enemies; i++)
			{
				if (enemy[i].comm_state == CS_NONEXISTENT)
					continue;
				// If we match an ID, terminate the client
				if (enemy[i].id == buf[1])
					enemy[i].comm_state = CS_NONEXISTENT;
			}
			break;
		}
		default:
		{
			sprintf(buf, "Received unknown packet #%d of type %d, length %d from %s", reject++, inbuf[0], packetlen, enemy[e].name);
			add_msg(MSG_COMPUTER, buf);
		}
	}
}

void do_communications(void)
{
	static int first_time = 1;		// Is this the first time through do_communications()?
	PACKET data;
	PACKET send;
	static PACKET old_packet;	// old player state update packet (anti-traffic usage)
	PACKET_IREQ_T ireqpacket;		// initialization request and acknowledge packet
	int packetlen;	// length of the packet in bytes
	int i, j, k, unused;
	int e;		// enemy id (who is this packet coming from, determined by InetAddress)
	int sent;
	FILE *fp;

	if (conn_type == CONN_WSOCK)
	{
//		sprintf(buf, "active_enemies: %d  enemy[0].comm_state = %d", active_enemies, active_enemies ? enemy[0].comm_state : -1);
//		textout(VisiblePage, font, buf, 64, 200, TEXT_COLOR);

		// Clear out the receive buffer if this is the first communications pass
		if (first_time)
		{
			while (net_query(s))
				net_receive(s, &inbuf, 1000, Connect);
			first_time = 0;
		}

		// While there are packets waiting, receive them.
		while (net_query(s))
		{
			packetlen = net_receive(s, &inbuf, 1000, Connect);
            last_packet_time = ms_time;
			// Search to match an address, to see who the packet is from
			for (i = 0; i < active_enemies; i++)
				if (!strcmp(Connect, enemy[i].addr))
				{
					// Fix people trying to reconnect but who are still ghosts in the game!
					if ((inbuf[0] == PACKET_CREQ) && (enemy[i].comm_state == CS_CONNECTED))
					{
						i = active_enemies;
						break;
					}

					// Set e, our enemy subscript #, to the one we found
					e = i;
					// Set the enemy's last-heard-from time to the current time
					enemy[e].latency = ms_time;
					// Set the enemy's keepalive count to 0, since we've heard from 'em
					enemy[e].keepalives = 0;
					// Increment the enemy's packet counter
					enemy[e].recvpackets++;
					// Find out how many packets have been sent to us
                    memcpy(&enemy[e].seqnum, &inbuf[packetlen - sizeof(int)], sizeof(int));
					break;
				}
			// Reduce the packet length to get rid of the extra int at the end
			packetlen -= sizeof(int);

			// If we didn't find someone in the enemy list, only process CREQ packets
			if (i == active_enemies)
			{
                switch (inbuf[0])
				{
					case PACKET_CREQ:
					{
						sprintf(buf, "Received connection request from %s", Connect);
						add_msg(MSG_COMPUTER, buf);

						// Check to see if this person is already in the game
						j = 0;
						for (i = 0; i < active_enemies; i++)
							if (enemy[i].comm_state == CS_CONNECTED)
								if (!strcmp(enemy[i].addr, Connect))
								{
									j = i;
									break;
								}

						if (!j)		// If it is a new player, find an ID
						{
		                    for (i = 0; i < active_enemies; i++)
		                        if (enemy[i].comm_state == CS_NONEXISTENT)
									break;
							if (i == active_enemies)
								active_enemies++;
						}
						else	// Otherwise it's someone taking over their former self
						{
							i = j;
							add_msg(MSG_COMPUTER, "%s is reconnecting...", enemy[i].name);
						}
						enemy[i].comm_state = CS_NONEXISTENT;
						strcpy(enemy[i].addr, Connect);
						ireqpacket.type = PACKET_CACK;
						// Send the new player the server's name
						strcpy(ireqpacket.name, player.name);
						// Find and assign an ID number to the new player, and save it
                        ireqpacket.id = 1;
						if (j)
							ireqpacket.id = enemy[i].id;
						else
						{
							// Loop through possible ID #'s
							for (j = 1; j < active_enemies + 1; j++)
							{
								// Check to see if this ID # is currently in use
								unused = 1;
								for (k = 0; k < active_enemies; k++)
									if ((enemy[k].comm_state != CS_NONEXISTENT) && (enemy[k].id == j))
									{
										unused = 0;
										break;
									}
								if (unused)
								{
									ireqpacket.id = j;
									break;
								}
							}
						}
						enemy[i].id = ireqpacket.id;
						enemy[i].latency = ms_time;
						enemy[i].keepalives = 0;
						enemy[i].sentpackets = 0;
						enemy[i].recvpackets = 0;
						enemy[i].seqnum = 0;
						enemy[i].comm_state = CS_INITIALIZING;
						Send(&ireqpacket, sizeof(PACKET_IREQ_T), enemy[i].addr);

    					sprintf(buf, "Assigning ID %d to new client %s", enemy[i].id, enemy[i].name);
						add_msg(MSG_COMPUTER, buf);
						break;
					}
                    case PACKET_EXIT:	// ignore extraneous exit packets
					{
						break;
					}
					default:
					{
						sprintf(buf, "Received unknown packet of type %d, length %d, from %s",
								inbuf[0], packetlen, Connect);
						add_msg(MSG_COMPUTER, buf);
					}
				}
			}
			else	// Otherwise we located them in the enemy list
				process_packet(inbuf[0], packetlen, e);
		}

		// If this is a client still in the process of initializing...
		if (game_state == GAME_STATE_INITCONN)
		{
			client_initialization();
		}
		else
		{
			while (ms_send > send_frequency) // Send player state updates at a regular interval
			{
				ms_send -= send_frequency;
				for (i = 0; i < ((comm_mode == COMM_SERVER) ? active_enemies : 1); i++)
				{
					if (enemy[i].comm_state != CS_CONNECTED)
						continue;
		            send.type = PACKET_PLSTATE;
					send.x = player.x;
					send.y = player.y;
					send.xoff = player.xoff;
					send.yoff = player.yoff;
					send.direction = player.direction;
					send.speed = player.speed;
					send.health = player.health;
					send.id = player.id;
					send.input = player.input;
	
					// Only transmit new packets if data has changed since last send
					if (memcmp(&old_packet, &send, sizeof(PACKET)))
					{
						if (debug)
						{
							sprintf(buf, "Sent: %d,%d (%d, %d)", send.x, send.y, send.xoff, send.yoff);
							textout(VisiblePage, font, buf, 64, 140, TEXT_COLOR);
						}
				        Send(&send, sizeof(PACKET), enemy[i].addr);
					}
		            memcpy(&old_packet, &send, sizeof(PACKET));
				}
			}
		}

		// Check for idle players (only server can do this)
		// Also send keepalives to players who we haven't heard from lately

		if (comm_mode == COMM_SERVER)
			for (i = 0; i < active_enemies; i++)
			{
				if (enemy[i].comm_state == CS_NONEXISTENT)
					continue;
				// If a player has been idle for over a minute, nuke em
	            if ((ms_time - enemy[i].latency) > 60000)
				{
					// Mark the timed out client as nonexistent
					enemy[i].comm_state = CS_NONEXISTENT;
					// Tell them that they timed out
					sprintf(buf, "%cSorry, but you timed out of the game!  %s had not received anything from you in over a minute.", PACKET_MSG, player.name);
			        Send(&buf[0], strlen(buf), enemy[i].addr);
					// Tell the other players about this
					sprintf(buf, "%c%s timed out of the game!", PACKET_MSG, enemy[i].name);
					relay_packet(&buf[0], strlen(&buf[1]), i);
					// Now tell them to get rid of the timed out client
					buf[0] = PACKET_KILLCL;
					buf[1] = enemy[i].id;
					relay_packet(&buf[0], 2, i);
				}
				else
				// Otherwise if they've been idle for over 10 seconds, send them a
				// keepalive every two seconds (ooh I love this implementation!)
				if ((ms_time - enemy[i].latency) > (10000 + (2000 * enemy[i].keepalives)))
				{
					enemy[i].keepalives++;
					buf[0] = PACKET_KPALIVE;
			        Send(&buf[0], 1, enemy[i].addr);
				}
			}
	}
}

/* relay_packet(): -------------------------------------------------------
 *   Sends a given packet to either the server or all of the other
 *   clients (if I am the server) besides the one whose packet is
 *   being relayed.
 */
void relay_packet(char *inbuf, int packetlen, int e)
{
	int i;
	PACKET *p;

	if (comm_mode == COMM_SERVER)
	{
		for (i = 0; i < active_enemies; i++)
		{
			if ((enemy[i].comm_state != CS_CONNECTED) || (i == e))
				continue;
			if (inbuf[0] == PACKET_PLSTATE)
			{
				// Ooh, this is cool.  Set the ID of the packet to the right enemy ID...
				p = (PACKET *) &inbuf[0];
				p->id = enemy[e].id;
				if (debug)
	                textprintf(VisiblePage, font, 64, 120 + (i * 10), TEXT_COLOR, "Relaying data from %s to %s ID=%d", enemy[e].name, enemy[i].name, p->id);
			}
			Send(&inbuf[0], packetlen, enemy[i].addr);
		}
	}
}

/* process_enemy_player_input(): -----------------------------------------
 *   Processes enemy player movement and turning, in the "modern" way.
 *   This means that when they press up, they go forwards.  When they press
 *   down, they go backwards.  Left and right actually turn the ship.
 */

#define ndown	(enemy[e].input & INPUT_FORWARD)
#define sdown	(enemy[e].input & INPUT_BACK)
#define wdown	(enemy[e].input & INPUT_LEFT)
#define edown	(enemy[e].input & INPUT_RIGHT)

void process_enemy_player_input(int e, signed int *ldir)
{
    fixed speed;
//	char ndown = 0, sdown = 0, wdown = 0, edown = 0;

	// Get input
/*        if (enemy[e].input & INPUT_FORWARD)
            ndown = 1;
        if (enemy[e].input & INPUT_BACK)
            sdown = 1;
        if (enemy[e].input & INPUT_LEFT)
            wdown = 1;
        if (enemy[e].input & INPUT_RIGHT)
            edown = 1; */

// *** Process enemy turning

		if (ms_turn > 40)        // And it's time for them to turn...
		{
//                ms_turn -= 40;
			if (wdown)
				enemy[e].direction -= 8;
			else
			{
				if (edown)
					enemy[e].direction += 8;
			}
		}

// Player input processing... moving
        // Increase acceleration if an arrow key has been held down
        // Or decrease it if a key was not held down...
        // But, to slow down general acceleration and deceleration,
        //  use the # of frames variable to only change these values
        //  every couple of frames.
        if (ms_accel > 40)
        {
//            ms_accel -= 40;
            if (ndown)    // If up is held down, accelerate
            {
                if (enemy[e].speed == 0)
                    enemy[e].speed += ftofix(0.50);				// was 0.75
                enemy[e].speed = enemy[e].speed + ftofix(0.15);		// was 0.25
            }
            else
            if (sdown)  // Go backwards..
            {
                if (enemy[e].speed == 0)
                    enemy[e].speed -= ftofix(0.75);
                enemy[e].speed = enemy[e].speed - ftofix(0.25);
            }
            else                // Otherwise, decelerate
            {
                if (fixtof(enemy[e].speed >= 0.0))
                {
                    enemy[e].speed = enemy[e].speed - ftofix(0.35);	// was 0.75
                    if (fixtof(enemy[e].speed) < 0.0)
                        enemy[e].speed = ftofix(0.0);
                }
                else
                {
                    enemy[e].speed = enemy[e].speed + ftofix(0.35); // was 0.75
                    if (fixtof(enemy[e].speed) > 0.0)
                        enemy[e].speed = ftofix(0.0);
                }
            }
        }

        // We can't go accelerating out of control! :o
        // Don't let the speed go over (or under) the player.maxspeed limit.
        // Double the speed if afterburners are on though. (shift)
        speed = player.maxspeed;
        if (enemy[e].input & INPUT_AFTERBURNER)
            speed += speed;
//        if (player.unit_carried)
//            speed /= 2;
        if (enemy[e].speed > speed)
            enemy[e].speed = speed;
        else
        if (enemy[e].speed < -speed)
            enemy[e].speed = -speed;

        *ldir = enemy[e].direction;
}

/* Send(): ----------------------------------------------------------------
 *   Sends a given packet to a given address, recording some statistics
 *   and adding on a packet sequence number to the end of the packet.
 */
int Send(void *Buffer, int BufferLength, char *Address)
{
	int e, i, seqnum = 0;
	static char *buf = 0;
	static int bufsize = 0;
	FILE *fp;

	if (comm_mode == COMM_NONE)
		return 1;

	// Resize our temporary buffer if necessary
	if (bufsize < BufferLength + sizeof(seqnum))
	{
		buf = (char *) realloc(buf, BufferLength + sizeof(seqnum));
		bufsize = BufferLength + sizeof(seqnum);
	}
	// Copy the packet data to our temporary buffer
	memcpy(buf, Buffer, BufferLength);

	// Search to see who this packet is going to,
	// and find out how many packets we've sent to them
	for (e = 0; e < active_enemies; e++)
		if (!strcmp(Address, enemy[e].addr))
		{
			seqnum = enemy[e].sentpackets++;	// increase the packet count sent to them
			break;
		}

	// Copy the packet sequence number to the end of the buffer
	// This lets them know how many packets we've sent them
	memcpy(&buf[BufferLength], &seqnum, sizeof(seqnum));

//	if (!buf)
/*	{
		fp = fopen("packet.log", "a");
		fprintf(fp, "Buffer=%p, BufferLength=%d, Address=%s\n",
				Buffer, BufferLength, Address);
		fprintf(fp, "buf=%p, bufsize=%d, seqnum=%d\n", buf, bufsize, seqnum);
		for (i = 0; i < BufferLength + sizeof(seqnum); i++)
			fputc(buf[i], fp);
		fprintf(fp, "\n");
		fclose(fp);
	} */

	// Send the packet
//	s->Send(buf, BufferLength + sizeof(seqnum), Flags, Address, AddressLength);

	net_assigntarget(s, Address);
	net_send(s, buf, BufferLength + sizeof(seqnum));

	return 0;
}

void send_unit_state(unit_t *u)
{
	char buf[800];
	int i;

	if ((comm_mode != COMM_NONE) && (u) && (u->owner == player.id))
	{
		if (debug)
			add_msg(MSG_COMPUTER, "Sending USTATE ID #%d", u->id);
		buf[0] = PACKET_USTATE;
		memcpy(&buf[1], u, sizeof(unit_t));		// unit data
		for (i = 0; i < ((comm_mode == COMM_SERVER) ? active_enemies : 1); i++)
			Send(&buf[0], 1 + sizeof(unit_t), enemy[i].addr);
	}
}

/* playersub(): -----------------------------------------------------------
 *   Takes a player ID and returns that player's subscript in the enemy[]
 *   array.
 */
int playersub(int id)
{
	int i;

	for (i = 0; i < active_enemies; i++)
		if (enemy[i].id == id)
			return i;

	add_msg(MSG_COMPUTER, "WARNING: Couldn't resolve player ID #%d", id);

	return 0;
}
