#ifndef __PATH__
#define __PATH__

#ifndef NULL
#define NULL	0
#endif

// Node structure for unit path linked lists
struct NODE {
    long f,h;
    int g,tmpg;
    int x,y;
    int NodeNum;
    struct NODE *Parent;
    struct NODE *Child[8];       // a node may have upto 8+(NULL) children.
    struct NODE *NextNode;       // for filing purposes
};
struct NODE *OPEN;
struct NODE *CLOSED;

/**************************************************************************/
/*                                 STACK                                  */
/**************************************************************************/
struct STACK {
    struct NODE *NodePtr;
    struct STACK *NextStackPtr;
};
struct STACK *Stack;

// void DisplayPath(int x1,int y1,int x2,int y2);
int TileNum(int x, int y);
int FreeTile(int x, int y);
void BoundaryTiles(void);

struct NODE *FindPath(long sx,long sy,long dx,long dy);
struct NODE *ReturnBestNode(void);
void GenerateSuccessors(struct NODE *BestNode,long dx,long dy);
void GenerateSucc(struct NODE *BestNode,long x, long y, long dx, long dy);
struct NODE *CheckOPEN(int tilenum);
struct NODE *CheckCLOSED(int tilenum);
void Insert(struct NODE *Successor);
void PropagateDown(struct NODE *Old);

void Push(struct NODE *Node);
struct NODE *Pop(void);

#endif
