// map.h: Header file for map related functions used by Bapple2.

#ifndef _RADAR_

#define _RADAR_

// Radar types
#define RADAR_NORMAL	0	// Normal expanding radar
#define RADAR_ANTI		1	// Anti-radar: Contracts while hiding terrain!

// Radar struct
typedef struct radar_t {
	// Creation parameters
	char type;			// Type of radar
	int interval;		// How often is the sweep
	int speed;			// How fast does the sweep expand (ms between radius increments)
	int range;			// How far does the radar go, radius in tiles
	int x, y;			// Radar origin location
	unit_t *u;			// Pointer to a unit providing this radar (NULL if no unit)

    // Pulse timing
	int last_sweep_time;// When was the last time a sweep was done
	int active;			// Is a sweep in progress

	// Expansion timing
	int last_sweep_tick;// When was the last time the radius was incremented
	int radius;			// What is the current radius of the radar

	struct radar_t *next;
} radar_t;

#endif
